(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-x11")

(define auto-detect (woo-read-first "/x11/autodetect"))
(define auto-xdriver (woo-get-option auto-detect 'xdriver "vesa"))

(define current-data (woo-read-first "/x11"))
(define current-xdriver (woo-get-option current-data 'xdriver #f))

(define (name+description x)
  (cons (woo-get-option x 'name)
        (woo-get-option x 'xdrivername)))

(define drivers-list (map name+description (woo-list "/x11/cards")))

(define (apply-defaults name)
  (cards current (or (list-index (lambda(x) (string=? (car x) name))
                                 drivers-list)
                     0)))

;;;;;;;;;;;;;;;

(define (return) (frame:replace "/x11"))

(define (make-row x)  (vector (car x) (cdr x)))

(define (get-xdriver)
  (car (list-ref drivers-list (cards current))))

(document:id cards
             (listbox
              layout-policy 100 -2
              columns 2
              (header (vector "Driver" "Description"))
              rows (map make-row drivers-list)))

(hbox
 (button (_ "Apply autodetected")
        (when clicked (apply-defaults auto-xdriver)))
 (spacer)
 (button (_ "OK")
         (when clicked
           (and (positive? (cards current))
                (woo-write "/x11" 'xdriver (get-xdriver)))
           (return)))
 (button (_ "Cancel")
         (when clicked
           (return))))

(apply-defaults (or current-xdriver ""))
