(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-x11")

(define auto-detect (woo-read-first "/x11/autodetect"))
(define auto-monitor (woo-get-option auto-detect 'monitor #f))

(define current-data (woo-read-first "/x11"))
(define current-monitor (woo-get-option current-data 'monitor #f))

(define (get-vendor monitor)
  (let ((vendor (woo-get-option (woo-read-first "/x11/monitor" 'name monitor)
                                'vendor)))
    (if (string-null? vendor)
        "Unknown"
        vendor)))

(define (get-monitors vendor-name)
  (if (string=? vendor-name "Unknown")
      (list auto-monitor)
      (woo-list-names (string-append "/x11/monitors/" vendor-name))))

(define (return) (frame:replace "/x11"))

(define vendors-list (woo-list-names "/x11/monitors"))

(define (append-detected)
         (vendors append-row "Unknown"))

(define (apply-defaults name)
  (let* ((vendor-name (get-vendor name))
         (vendor-index (string-list-index vendor-name vendors-list)))
    (vendors current (or vendor-index (length vendors-list)))
    (let ((monitors-list (get-monitors vendor-name)))
      (monitors rows monitors-list
                current (string-list-index name monitors-list)))))

(hbox layout-policy 100 -1
      (label (_ "Vendor"))
      (document:id vendors
                   (combobox
                    layout-policy -2 -1
                    rows vendors-list
                    (when selected
                      (monitors rows (get-monitors (vendors text))
                                current 0)))))
(document:id monitors
             (listbox
              layout-policy 100 -2
              header (vector (_ "Model"))))

(hbox
 (button (_ "Apply autodetected")
        activity (->bool auto-monitor)
        (when clicked (apply-defaults auto-monitor)))
 (spacer)
 (button (_ "OK")
         (when clicked (woo-write "/x11" 'monitor (monitors text))
               (return)))
 (button (_"Cancel")
         (when clicked (return))))

(and (global 'frame:next)
     (document:root (when loaded
                      (frame:next-activity #f)
                      (frame:back-activity #f))))

;;append automatically detected monitor if not in list
(and auto-monitor
     (string=? (get-vendor auto-monitor) "Unknown")
     (append-detected))

(apply-defaults (or current-monitor ""))
